<?php
//##############################################################################
//## pFORUM - Stats                                                           ##
//## Thomas Ehrhardt 2005                                                     ##
//## www.powie.de                                                             ##
//##############################################################################

require("pforum_main.php");
$pagetitle.=" - Statistik";

if ($user_id==0) {
    header ("Location: index.php");
}
require($pdir."/kopf.php");

$smarty_forum->caching = 2;
$smarty_forum->cache_lifetime = 21601;
if (!$smarty_forum->is_cached('forum_stats.tpl')) {
    //############## Anzahl Boards###########
    $anzahl = $pdb->fetch_row("SELECT Count(*) as total FROM $tab_board");
    $stat['boardcount']=$anzahl['total'];

    //############## Anzahl User ###########
    $anzahl = $pdb->fetch_row("SELECT Count(*) as total FROM $tab_user");
    $stat['usercount']=$anzahl['total'];

    //############## Anzahl Threads ###########
    $anzahl = $pdb->fetch_row("SELECT Count(*) as total FROM $tab_thread");
    $stat['threadcount']=$anzahl['total'];

    //############## Anzahl Posts ###########
    $anzahl = $pdb->fetch_row("SELECT Count(*) as total FROM $tab_post");
    $stat['postcount']=$anzahl['total'];

    //############## Files  ##################
    $anzahl = $pdb->fetch_row("SELECT Count(*) as total FROM $tab_fileinfo");
    $stat['filecount']=$anzahl['total'];

    //############## User-Avatare ###########
    clearstatcache();
    $fp=opendir($pdir_avataruser);
    $fsize=0;
    while ($datei = readdir($fp)) {
        if (is_file("$pdir_avataruser/$datei")) {
            $files = $files +1;
        }
    }
    closedir($fp);
    $stat['avatarcount']=$files;


    //Post und Thread Statistiken ##################################################
    //Minimales Jahr abfragen
    $years = $pdb->fetch_row("
                    Select min(year(From_Unixtime(starttime))) as minjahr,
    					   max(year(From_Unixtime(starttime))) as maxjahr
                    From $tab_thread Where starttime > 0");
    $minjahr   = $years['minjahr'];
    $maxjahr   = $years['maxjahr'];

    //TPM
    for ($i = $minjahr; $i <= $maxjahr; $i++) {
        unset ( $data );
    	$sumjahr = 0;
        $sjahr[$i]['jahr'] = $i;
        //Jahr Daten holen
    	$sqlbefehl = "Select month(From_Unixtime(t.starttime)) as monat, count(t.id) as counter
    	              From $tab_thread t
                      Where year(From_Unixtime(t.starttime)) = '$i'
    	              Group By month(From_Unixtime(t.starttime)) Order By monat";
    	$getdata = $pdb->query($sqlbefehl);
    	while ( $cdata = $pdb->fetch($getdata) ) {
    		$data[intval($cdata['monat'])]  = $cdata['counter'];
    		$sumjahr = $sumjahr + $cdata['counter'];
    	}
    	for ( $x=1; $x <=12; $x++ ) {
    	    $sjahr[$i]['tpm'][$x] = $data[$x];
    	}
    	$sjahr[$i]['sum'] = $sumjahr;
    }
    $smarty_forum->assign('stpm',$sjahr);

    //PPM
    unset($sjahr);
    for ($i = $minjahr; $i <= $maxjahr; $i++) {
        unset ( $data );
    	$sumjahr = 0;
        $sjahr[$i]['jahr'] = $i;
        //Jahr Daten holen
    	$sqlbefehl = "Select month(From_Unixtime(p.time)) as monat, count(p.id) as counter
    	              From $tab_post p
                      Where year(From_Unixtime(p.time)) = '$i'
    	              Group By month(From_Unixtime(p.time)) Order By monat";
    	$getdata = $pdb->query($sqlbefehl);
    	while ( $cdata = $pdb->fetch($getdata) ) {
    		$data[intval($cdata['monat'])]  = $cdata['counter'];
    		$sumjahr = $sumjahr + $cdata['counter'];
    	}
    	for ( $x=1; $x <=12; $x++ ) {
    	    $sjahr[$i]['tpm'][$x] = $data[$x];
    	}
    	$sjahr[$i]['sum'] = $sumjahr;
    }
    $smarty_forum->assign('sppm',$sjahr);

    //UPM
    //Minimales Jahr abfragen
    $years = $pdb->fetch_row("Select min(year(From_Unixtime(joined))) as minjahr,
    					      max(year(From_Unixtime(joined))) as maxjahr
                              From $tab_user Where joined > 0");
    $minjahr   = $years['minjahr'];
    $maxjahr   = $years['maxjahr'];

    unset($sjahr);
    for ($i = $minjahr; $i <= $maxjahr; $i++) {
        unset ( $data );
    	$sumjahr = 0;
        $sjahr[$i]['jahr'] = $i;
        //Jahr Daten holen
    	$sqlbefehl = "Select month(From_Unixtime(joined)) as monat, count(id) as counter
    	              From $tab_user
                      Where year(From_Unixtime(joined)) = '$i'
    	              Group By month(From_Unixtime(joined)) Order By monat";
    	$getdata = $pdb->query($sqlbefehl);
    	while ( $cdata = $pdb->fetch($getdata) ) {
    		$data[intval($cdata['monat'])]  = $cdata['counter'];
    		$sumjahr = $sumjahr + $cdata['counter'];
    	}
    	for ( $x=1; $x <=12; $x++ ) {
    	    $sjahr[$i]['tpm'][$x] = $data[$x];
    	}
    	$sjahr[$i]['sum'] = $sumjahr;
    }
    $smarty_forum->assign('supm',$sjahr);

    $smarty_forum->assign('stat',$stat);
}
$smarty_forum->display('forum_stats.tpl');
$smarty_forum->caching = 0;
require($pdir."/fuss.php");
?>