<?php
//##############################################################################
//## pSys                                                                     ##
//## Thomas Ehrhardt - 2006 - 2009                                            ##
//## MAIN                                                                     ##
//##############################################################################

/* $Id: pmain.inc.php,v 1.118 2010/11/04 16:35:17 powie Exp $ */

//Blame UNION
if ( stristr($_SERVER['REQUEST_URI'],'union+') ) {
	header("HTTP/1.1 403 Forbidden");
	exit();
}

//Parsing Time Start
$mtime1 = microtime();
$mtime1 = explode(" ",$mtime1);
$mtime1 = $mtime1[1] + $mtime1[0];
$rendstarttime = $mtime1;
$time = time();

//GZIP
ob_start ("ob_gzhandler");

//DEBUG

if ( $_REQUEST['debugmode'] == 1) {
	error_reporting(E_ALL);
} else {
	error_reporting(6135);
}

//benötigte Files
$pdir = dirname(__file__)."/..";                      	// Verzeichniss auf dem Webserver
$pdir = realpath($pdir);         						// lib entfernen
require_once($pdir.'/config.inc.php');					// configs
require_once($pdir.'/lib/config.inc.php');				// lib configs
require_once($pdir.'/lib/tabnames.inc.php');			// Tabellen Namen
require_once($pdir.'/lib/functions.inc.php');			// Funktionen
require_once($pdir.'/lib/creator.inc.php');				// Creator
require_once($pdir.'/lib/pfilter.inc.php');				// Filter
require_once($pdir.'/lib/editor.inc.php');				// Editoren
require_once($pdir.'/lib/filehandler.inc.php');			// Ddateihandling
require_once($pdir.'/lib/checker.inc.php');				// Checker
require_once($pdir.'/lib/smarty/Smarty.class.php');		// Smarty
require_once($pdir.'/lib/classes.inc.php');				// Klassen
require_once($pdir.'/lib/mail.inc.php');				// Mail Support
require_once($pdir.'/lib/db.inc.php');				    // DB Tricks
require_once($pdir.'/lib/recaptchalib.php');			// Recaptcha

//DIRs setzen
$pdir_avatar        = $pdir."/media/avatar";
$pdir_avataruser    = $pdir."/media/avataruser";
$pdir_cache         = $pdir."/cache";
$pdir_ticons        = $pdir."/media/icon";
$pdir_smilies       = $pdir."/smilies";
$pdir_admin         = $pdir."/admin";
$pdir_media         = $pdir."/media";
$pdir_mod           = $pdir."/mod";
$pdir_opt           = $pdir."/opt";
$pdir_panels        = $pdir."/panels";
$pdir_tpl           = $pdir."/tpl";
$pdir_lib           = $pdir."/lib";
$pdir_images        = $pdir."/images";
$pdir_lang      	= $pdir."/lang";

//URLS setzen
$purl_admin  	    = $purl."/admin";
$purl_avatar        = $purl."/media/avatar";
$purl_avataruser    = $purl."/media/avataruser";
$purl_cache         = $purl."/cache";
$purl_ticons        = $purl."/media/icon";
$purl_forum         = $purl."/forum";
$purl_images 	    = $purl."/images";
$purl_smilies 	    = $purl."/smilies";
$purl_media         = $purl."/media";
$purl_mod 	        = $purl."/mod";
$purl_opt	        = $purl."/opt";
$purl_user	        = $purl."/user";
$purl_lib           = $purl."/lib";

//Vorkonfigurationen
date_default_timezone_set($psys_timezone);

//DB starten
if ( !isset($pdb) ) {
	$pdb = new psysdb($sqluser, $sqlpass, $database, $sqlhost);
}
$serverid=$pdb->serverid; // für alte Queries

//Options init
$popt = new psys_options;
//var_dump($popt->opt);

//Setup lesen
$pset=$pdb->fetch_row("Select * From $tab_setup");
if ( !isset($pagetitle) ) {
	$pagetitle= $pset['systitle'];      //Titel zuweisen
}
$pstyle  = $pset['design'];             //Design zuweisen
if ( $pstyle == "") { $pstyle = "default"; }

//Userstyle zufügen!
if ( 1 == $pset['selectstyle'] and $_COOKIE['psysuserstyle'] !="" ) {
    $pstyle = basename($_COOKIE['psysuserstyle']);
}

//Style CSS URL und Ordner
$pdesign = $purl."/style/".$pstyle."/design.css";
$pdir_style         = $pdir."/style/".$pstyle;
$pdir_stylehome     = $pdir."/style";
$purl_style			= $purl.'/style/'.$pstyle;
include($pdir_style."/styledef.inc.php");

//Vorbelegungen
$zps 				= 20;
$ups                = 30;
$panelcontents      = 10;                           //Inhalte Zeilen in Panels
$pshowframe 		= 1;							//Frame zeigen
$pshowhead 			= 1;

//sonstige Settings
$pversion 	= "0.8.0";
$pversionint= "0.7.5";


//Session starten, jetzt gehts loooooos
@session_start();
define('inpsys',TRUE);
$tagmanager = new psys_tagmanager;		//Tagmananger!

//BaseArea setzen ##############################################################
$basearea = $pdb->escape(psys_fcache('basearea'));
if ($basearea == "") { $basearea='default'; }
$ba=$pdb->fetch_row("Select * From $tab_area Where area = '$basearea'");
if ( "" == $ba['area']) {
    $basearea="default";
    $_SESSION['fcache']['basearea'] = 'default';
}

//Login lesen ##################################################################
require_once($pdir.'/logincheck.inc.php');

//Language Core laden ##########################################################
if ($pset['language'] == "" )  { $pset['language'] = 'de.ini'; }
if ($ba['language'] != "" )    { $pset['language'] = $ba['language']; }
if ( "" != basename($_COOKIE['psysguestlang']) ) { $pset['language'] = $_COOKIE['psysguestlang']; }
if ( "" != $user['user_lang'] )  { $pset['language'] = $user['user_lang']; }
if ( file_exists("$pdir_lang/$pset[language]") and is_file("$pdir_lang/$pset[language]") ) {
    psys_language("$pdir_lang/$pset[language]");
    setlocale (LC_ALL, PSL_setlocale);
} else {
    echo "ERROR Reading Language Definition File: $pdir_lang/$pset[language]";
    exit();
}

//SmartyCore Init ##############################################################
$smarty_core = new SmartyMLDB(PSL_localtag);
$smarty_core->template_dir=$pdir."/tpl/";
//$smarty_core->force_compile = true;
if ( $_REQUEST['debugmode'] == 1) {
	$smarty_core->debugging = true;
}
//Einige Smarty Caches löschen wenn angefordert
if ( $flag_clear_usercache ) {
    $smarty_core->clear_cache('panel_user.tpl');
    $smarty_core->clear_cache('forum_useronline.tpl');
    unset($flag_clear_usercache);
}


//Login Pflicht wenn kein Gastzugang
if ( $pset['access'] != "all" and $pset['access'] != "" and $user_id == 0 ) {
	$pshowframe = 0;
	if ( !( basename($_SERVER['PHP_SELF']) == "getpass.php" or basename($_SERVER['PHP_SELF']) == "changepass.php"
	        or basename($_SERVER['PHP_SELF']) == "edituser.php" ) )
	{
		require($pdir."/login.inc.php");
		exit();
	}
}

//BlackIP Check
if (  $user['usertyp'] != "admin" and $user['usertyp'] != "moderate" ) {
    if ( checkBlackIP() ) {
    	//$pshowframe = 0;
        //$pagetitle="IP gesperrt";
        //include("$pdir/kopf.php");
        //msgbox("Deine IP Adresse ist gesperrt");
        //include("$pdir/fuss.php");
        header("HTTP/1.1 403 Forbidden");
        exit();
    }
}

//$puserminlevel check
if ( isset($puserminlevel) and $puserminlevel > 0 ) {
	if ( $user['intlevel'] < $puserminlevel ) {
		$pagetitle = "Level nicht ausreichend";
        include("$pdir/kopf.php");
        msgbox("INT Level nicht ausreichend");
        include("$pdir/fuss.php");
        exit();
	}
}

//Passwort abgelaufen
/*
if ( isset($user['id']) and $user['usertyp'] != 'admin' and $user['pwdcheck'] < ( time() - $ppwdexpire )
     and basename($_SERVER['PHP_SELF']) != "newpass.php" ) {
     header("Location: $purl_user/newpass.php");
     exit();
}
*/

//Robot Log
/*
if ( $r = checkRobot() ) {
	file_put_contents("$pdir_cache/$r.log",date("d.m.Y, H:i", time() )." - ".$_SERVER['REQUEST_URI'] );
}
*/
?>